<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\CategoriaEquipService;
use FM\Traits\TResponse;

class CategoriaEquipController {
    use TResponse;

    protected $dataSourceName = 'fcm_checklistagend';
    protected $CategoriaEquipService;
   
    public function __construct(CategoriaEquipService $CategoriaEquipService) {
        $this->CategoriaEquipService = $CategoriaEquipService;
    }

    public function getCategorias(Request $request) {
        try {
            $data = $this->CategoriaEquipService->getCategorias();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function salvarCategoria(Request $request) {
        try {
            $parametro = $request->getParameters();
            $this->CategoriaEquipService->salvarCategoria($parametro);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteCategorias(Request $request) {
        try {
            $parametro = $request->getParameters();
            $this->CategoriaEquipService->deleteCategorias($parametro);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getCategManutencao(Request $request) {
        try {
            $data = $this->CategoriaEquipService->getCategManutencao();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getEquip(Request $request) {
        try {
            $data = $this->CategoriaEquipService->getEquip();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}

?>