<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\EscopoManutService;
use FM\Traits\TResponse;

class EscopoManutController {
    use TResponse;
    protected $EscopoManutService;
   
    public function __construct(EscopoManutService $EscopoManutService) {
        $this->EscopoManutService = $EscopoManutService;
    }
    
    public function saveEscopo(Request $request) {
        try {
            $params = $request->getParameters();
            $this->EscopoManutService->saveEscopo($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getEscoposManutencao(Request $request) {
        try {
            $data = $this->EscopoManutService->getEscoposManutencao();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteEscopos(Request $request) {
        try {
            $params = $request->getParameters();
            $this->EscopoManutService->deleteEscopos($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}

?>