<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\InsumoService;
use FM\Traits\TResponse;

class InsumoController {
    use TResponse;

    protected $InsumoService;
   
    public function __construct(InsumoService $InsumoService) {
        $this->InsumoService = $InsumoService;
    }

    public function getInsumos(Request $request) {
        try {
            $data = $this->InsumoService->getInsumos();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function salvarInsumo(Request $request) {
        try {
            $parametro = $request->getParameters();
            $this->InsumoService->salvarInsumo($parametro);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteInsumos(Request $request) {
        try {
            $parametro = $request->getParameters();
            $this->InsumoService->deleteInsumos($parametro);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function insertFotosInsumo(Request $request) {
        try {
            $parametro = $request->getParameters();
            $this->InsumoService->insertFotosInsumo($parametro);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFotosInsumo(Request $request) {
        try {
            $parametro = $request->getParameters();
            $data = $this->InsumoService->getFotosInsumo($parametro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteFotoInsumo(Request $request) {
        try {
            $parametro = $request->getParameters();
            $data = $this->InsumoService->deleteFotoInsumo($parametro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getUniMedida(Request $request) {
        try {
            $data = $this->InsumoService->getUniMedida();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}

?>