<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\UnidadeMedidaService;
use FM\Traits\TResponse;

class UnidadeMedidaController {
    use TResponse;
    protected $UnidadeMedidaService;
   
    public function __construct(UnidadeMedidaService $UnidadeMedidaService) {
        $this->UnidadeMedidaService = $UnidadeMedidaService;
    }
    
    public function saveUnidadeMedida(Request $request) {
        try {
            $params = $request->getParameters();
            $this->UnidadeMedidaService->saveUnidadeMedida($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getUnidadesMedida(Request $request) {
        try {
            $data = $this->UnidadeMedidaService->getUnidadesMedida();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteUnidadesMedida(Request $request) {
        try {
            $params = $request->getParameters();
            $this->UnidadeMedidaService->deleteUnidadesMedida($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}

?>