<?php

namespace FM\Service;

use FM\Factory\ComentOrdemServFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class ComentOrdemServService {

    protected $ComentOrdemServFactory;
    protected $Environment;
    protected $newCode;

    public function __construct (EntityManager $entityManager, ComentOrdemServFactory $ComentOrdemServFactory, Environment $Environment, NewCode $newCode) {
        $this->ComentOrdemServFactory = $ComentOrdemServFactory;
        $this->connection             = $entityManager->getConnection();
        $this->Environment            = $Environment;
        $this->newCode                = $newCode;
    }

    public function inserirComentarios($parametros) {
        $NRORG = 20;
        $this->connection->beginTransaction();

        try {

            $NRCOMENTORDEMSERV = $this->newCode->getCodeByTableName("FCM_COMENTORDEMSERV", $NRORG, 1, 10, true);

            $comentario = array(
              "NRCOMENTORDEMSERV" => $NRCOMENTORDEMSERV,
              "NRORDEMSERV"      => $parametros['NRORDEMSERV'],
              "NRFUNCCOMENTARIO" => $parametros['NRFUNCCOMENTARIO'],
              "DSCOMENTARIO"     => $parametros['DSCOMENTARIO'],
            );

            $this->ComentOrdemServFactory->inserirComentarios($comentario);

            $this->connection->commit();
            $response = 'OK';

        } catch(\Exception $e) {
          $this->connection->rollback();
          $response = ($e->getMessage());
      }
       return $response;
    }
}

?>