/* eslint-disable*/
import {
  Http, IDictionary, Metadata, Router,
} from '@zeedhi/core';
import {
  AlertService, Button, Col, DialogService, FileInput, Form,
  LoadingService, Modal, ModalService, Row, Text, TextInput, Select, SelectMultiple,
} from '@zeedhi/common';
import { IterableCarousel, IterableComponentRender } from '@zeedhi/teknisa-components-common';
import { FileUpload } from './FileUpload';

export class ControllerAtivosInsumos {
  private modaDeCopia!: Modal;

  private modalCriacaoInsumos!: Modal;

  public colocarNrNaRota = ({ component }: any) => { component.to = `/${component.name.split('_')[1]}?${window.location.search.slice(1)}`; };

  public direcionarAtivos = ({ component }: any) => Router.replace(`/ativos?${component.name.split('_')[1]}`);

  public botaoSalvar = ({ component }: any) => component.name = (window.location.search === '') ? 'BotaoSalvar_Salvar' : 'BotaoSalvar_Modificar';

  private dadosOriginal: IDictionary = {};

  private dadosDosInsumo: any = [];public getDadosInsumo = ({ component }: any) => component.datasource.updateData(this.dadosDosInsumo);

  private tituloPagina: string = '';

  private categoria: any;

  private titulo: string = '';

  private visibilidadeBotao: boolean = false;

  private visibilidadeAdicionar: boolean = false;

  public proximaPagina({ component }: any) {
    component.parent.datasource.page += 1;
    if (component.parent.paginationLength === component.parent.datasource.page) {
      component.disabled = true;
    }
    component.parent.datasource.get();
    Metadata.getInstance<Button>(`BotaoPaginaAnterior_${component.name.split('_')[1]}`).disabled = false;
  }

  public paginaAnterior({ component }: any) {
    if (component.parent.datasource.page > 1) {
      component.parent.datasource.page -= 1;
      if (component.parent.datasource.page === 1) {
        component.disabled = true;
      }
      component.parent.datasource.get();
      Metadata.getInstance<Button>(`BotaoProximaPagina_${component.name.split('_')[1]}`).disabled = false;
    }
  }

  public MaisQueUmaPagina({ component }: any) {
    component.disabled = !(Metadata.getInstance<IterableComponentRender>(component.name.split('_')[1]).paginationLength > 1);
  }

  public espandirCard({ component }: any) {
    component.parent.expanded = !component.parent.expanded;
  }

  public async abrirModalCopiaTipoManutencao({ component }: any) {
    const nome = component.name.split('_');
    const itera = Metadata.getInstance<IterableComponentRender>(nome[2].replaceAll('-', '_'));
    this.modaDeCopia = ModalService.create({
      name: 'modaDeCopia',
      persistent: true,
      grid: {
        cols: 4,
        lg: 4,
        md: 4,
        sm: 5,
      },
      children: [
        {
          name: 'fromTypescriptHeader',
          component: 'ZdHeader',
          color: 'transparent',
          padless: true,
          elevation: 0,
          leftSlot: [
            {
              name: 'titleText',
              component: 'ZdText',
              text: 'Listas disponiveis',
              cssClass: 'titulo-do-modal',
            },
          ],
          rightSlot: [
            {
              name: 'closeModalButton_modaDeCopia',
              component: 'ZdButton',
              icon: true,
              iconName: 'mdi-close',
              small: true,
              events: {
                click: () => this.fecharModalCopiaTipoManutencao(),
              },
            },
          ],
        },
        {
          name: 'formDeCopia',
          component: 'ZdForm',
          children: [
            {
              name: `listasDisponiveis_${nome[1]}`,
              label: 'Selecione uma lista',
              component: 'ZdSelect',
              grid: {
                cols: 12,
              },
              dataText: 'NMTIPOMANUTENCAO',
              dataValue: 'NRTIPOMANUTENCAO',
              autocomplete: false,
              datasource: {
                type: 'rest',
                loadAll: true,
              },
              events: {
                onBeforeMount: (componente: any) => this.listasDiponiveis(componente, itera),
              },
              validations: {
                required: {},
              }
            },
          ],
        },
        {
          name: 'Divisor',
          component: 'ZdDivider',
          cssClass: 'espaco-entre-conteudos'
        },
        {
          name: 'LinhaComBoaoDeCopiaDosModal',
          component: 'ZdCol',
          align: 'end',
          cssClass: 'espaco-entre-conteudos',
          children: [
            {
              name: 'BotaoCancelaCopiarCard',
              component: 'ZdButton',
              label: 'Cancelar',
              outline: true,
              width: '8vw',
              cssClass: 'zd-mr-2',
              events: {
                click: '{{ControllerAtivosInsumos.fecharModalCopiaTipoManutencao}}',
              },
            },
            {
              name: 'BotaoCopiarCard',
              component: 'ZdButton',
              label: 'Copiar',
              width: '8vw',
              events: {
                click: () => this.copiarDados(nome[1], itera),
              },
            },
          ],
        }
      ],
    });
    this.modaDeCopia.show();
  }

  public async fecharModalCopiaTipoManutencao() {
    await this.modaDeCopia!.hide();
    this.modaDeCopia?.destroy();
  }

  public async abrirModalCriacaoInsumos() {
    this.modalCriacaoInsumos = await ModalService.createFromJson('/modais/layout_modalCriacaoInsumos', true);
    this.modalCriacaoInsumos.show();
  }

  public async fecharModalCriacaoInsumos() {
    await this.modalCriacaoInsumos.hide();
    await this.modalCriacaoInsumos?.destroy();
  }

  public async abrirModalCriacaoCategoria() {
    this.modalCriacaoInsumos = await ModalService.createFromJson('/modais/layout_modalCriacaoCategoria', true);
    this.modalCriacaoInsumos.show();
  }

  public async fecharModalCriacaoCategoria() {
    await this.modalCriacaoInsumos.hide();
    await this.modalCriacaoInsumos?.destroy();
  }

  public exibirImagem({ component }: any) {
    let telaInsumo = false;
    let colunaImgs: any;
    if (component.name.split('_')[1] === 'carouselImagemDosInsumos') {
      telaInsumo = true;
      colunaImgs = Metadata.getInstance<Col>('ColComCarroselDeImagens');
    }
    const imagens = Metadata.getInstance<IterableCarousel>(component.name.split('_')[1]);
    let imagensAtualizada: any = [];
    if (imagens.iterable) {
       imagensAtualizada = imagens.iterable.datasource.data.filter((elemento: any) => elemento.id.split('_')[0] === 'banco');
    }
    if (component.value.length) {
      if (telaInsumo) colunaImgs.isVisible = true;
      component.value.forEach((imagem: any, pos: number) => {
        imagensAtualizada.push({
          id: `cliente_${pos}`,
          src: window.URL.createObjectURL(imagem),
        });
      });
    } else {
      if (telaInsumo) colunaImgs.isVisible = false;
    }
    imagens.iterable.datasource.updateData(imagensAtualizada);
  }

  public dadosAtivo() {
    Http.get('dadosAtivos').then((resposta: IDictionary) => {
      const dadosAtivos = resposta.data.dataset.ativos;
      Metadata.getInstance<SelectMultiple>('CampoParaFiltrar_IteracaoDadosCardAtivos_CDEQUIPAMENTO').updateItems(dadosAtivos.map((dados: any) => dados.CDEQUIPAMENTO));
      const nomeCategoria = dadosAtivos.map((dados: any) => dados.NMCATEGORIAEQUIP);
      Metadata.getInstance<SelectMultiple>('CampoParaFiltrar_IteracaoDadosCardAtivos_NMCATEGORIAEQUIP').updateItems(nomeCategoria.filter((nome: string, pos: number) => nomeCategoria.indexOf(nome) === pos));
      const nomes = dadosAtivos.map((dados: any) => dados.NMEQUIPAMENTO);
      Metadata.getInstance<SelectMultiple>('CampoParaFiltrar_IteracaoDadosCardAtivos_NMEQUIPAMENTO').updateItems(nomes.filter((nome: string, pos: number) => nomes.indexOf(nome) === pos));
      const situacao = dadosAtivos.map((dados: any) => dados.IDSITUACAO);
      Metadata.getInstance<SelectMultiple>('CampoParaFiltrar_IteracaoDadosCardAtivos_IDSITUACAO').updateItems(situacao.filter((nome: string, pos: number) => situacao.indexOf(nome) === pos));
      const tipoManutencao = (dadosAtivos.map((dados: any) => dados.TIPOSMANUTENCAO.split(','))).flat(1);
      const select = Metadata.getInstance<SelectMultiple>('CampoParaFiltrar_IteracaoDadosCardAtivos_TIPOSMANUTENCAO');
      select.updateItems(tipoManutencao.filter((nome: string, pos: number) => tipoManutencao.indexOf(nome) === pos));
      Metadata.getInstance<IterableComponentRender>('IteracaoDadosCardAtivos').datasource.updateData(dadosAtivos);
      this.dadosOriginal.IteracaoDadosCardAtivos = dadosAtivos;
      this.MaisQueUmaPagina({
        component: Metadata.getInstance<Button>('BotaoProximaPagina_IteracaoDadosCardAtivos'),
      });
    });
  }

  public dadosCategoria() {
    Http.get('dadosCategoria').then((resposta: IDictionary) => {
      const dadosCategoria = resposta.data.dataset.categoria;
      Metadata.getInstance<SelectMultiple>('CampoParaFiltrar_IteracaoDadosCardCategoria_NMCATEGORIAEQUIP').updateItems(dadosCategoria.map((dados: any) => dados.NMCATEGORIAEQUIP));
      const nomeTipoManutencao = (dadosCategoria.map((dados: any) => dados.NMTIPOMANUTENCAO.split(','))).flat(1);
      Metadata.getInstance<SelectMultiple>('CampoParaFiltrar_IteracaoDadosCardCategoria_NMTIPOMANUTENCAO').updateItems(nomeTipoManutencao.filter((nome: string, pos: number) => nomeTipoManutencao.indexOf(nome) === pos));
      const nomesEquipamento = (dadosCategoria.map((dados: any) => (dados.NMEQUIPAMENTO !== null) ? dados.NMEQUIPAMENTO.split(',') : [])).flat(1);
      Metadata.getInstance<SelectMultiple>('CampoParaFiltrar_IteracaoDadosCardCategoria_NMEQUIPAMENTO').updateItems(nomesEquipamento.filter((nome: string, pos: number) => nomesEquipamento.indexOf(nome) === pos));
      Metadata.getInstance<IterableComponentRender>('IteracaoDadosCardCategoria').datasource.updateData(dadosCategoria);
      this.dadosOriginal.IteracaoDadosCardCategoria = dadosCategoria;
      this.MaisQueUmaPagina({
        component: Metadata.getInstance<Button>('BotaoProximaPagina_IteracaoDadosCardCategoria'),
      });
    });
  }

  public categoriaManutecao({ component }: any){
    Http.get('/CategoriaManut').then((resposta: any) => {
      component.datasource.updateData(resposta.data.dataset.categorias[0]);
    })
  }

  public dadosInsumo() {
    Http.get('insumos').then((resposta: IDictionary) => {
      const dadosInsumo = resposta.data.dataset.insumo;
      Metadata.getInstance<SelectMultiple>('CampoParaFiltrar_IteracaoDadosCardInsumos_CDINSUMO').updateItems(dadosInsumo.map((dados: any) => dados.CDINSUMO));
      const nomeInsumo = dadosInsumo.map((dados: any) => dados.NMINSUMO);
      Metadata.getInstance<SelectMultiple>('CampoParaFiltrar_IteracaoDadosCardInsumos_NMINSUMO').updateItems(nomeInsumo.filter((nome: string, pos: number) => nomeInsumo.indexOf(nome) === pos));
      const unidadeMedida = dadosInsumo.map((dados: any) => dados.NMUNIDADEMEDIDA);
      Metadata.getInstance<SelectMultiple>('CampoParaFiltrar_IteracaoDadosCardInsumos_NMUNIDADEMEDIDA').updateItems(unidadeMedida.filter((nome: string, pos: number) => unidadeMedida.indexOf(nome) === pos));
      Metadata.getInstance<IterableComponentRender>('IteracaoDadosCardInsumos').datasource.updateData(dadosInsumo);
      this.dadosOriginal.IteracaoDadosCardInsumos = dadosInsumo;
      this.MaisQueUmaPagina({
        component: Metadata.getInstance<Button>('BotaoProximaPagina_IteracaoDadosCardInsumos'),
      });
    });
  }

  public filtrarDados(dados: IDictionary, valoresASerFiltrado: any, colunaAFiltrar: any) {
    const dadosFiltrados: any = [];
    dados.forEach((dadoUnitario: any) => {
      if (dadoUnitario[colunaAFiltrar] !== null) {
        dadoUnitario[colunaAFiltrar].split(',').forEach((dadosColuna: any) => {
          if (valoresASerFiltrado.includes(dadosColuna)) {
            dadosFiltrados.push(dadoUnitario);
            return false;
          }
        });
      }
    });
    return dadosFiltrados;
  }

  public async filtrar({ component }: any, dadosOriginal = this.dadosOriginal) {
    const nomes = component.name.split('_');
    const iterable = Metadata.getInstance<IterableComponentRender>(nomes[1]);
    iterable.datasource.updateData(dadosOriginal[nomes[1]]);
    iterable.datasource.searchIn.forEach((colunas: string) => {
      const select = Metadata.getInstance<any>(`CampoParaFiltrar_${nomes[1]}_${colunas}`).value;
      if (select && select.length) {
        const dadosIterable = (iterable.datasource as any);
        iterable.datasource.updateData(this.filtrarDados(dadosIterable.allData || dadosIterable.data, select, colunas));
      }
    });
    this.MaisQueUmaPagina({
      component: Metadata.getInstance<Button>(`BotaoProximaPagina_${nomes[1]}`),
    });
  }

  public dadosDatasourceSuperior({ component }: any) {
    const parentIterable = Metadata.getInstance<IterableComponentRender>('IteracaoDadosCardCategoria');
    const id = component.name.split('_')[1];
    const parentIndex = parentIterable.datasource.data.findIndex((row) => row.NRCATEGORIAEQUIP === Number(id));
    const dadosDataSource: any = [];
    if (parentIterable.datasource.data[parentIndex].NMEQUIPAMENTO !== null) {
      parentIterable.datasource.data[parentIndex].NMEQUIPAMENTO.split(',').forEach((dados: any, pos: number) => {
        dadosDataSource.push({
          id: pos,
          name: dados,
        });
      });
    }
    component.datasource.updateData(dadosDataSource);
  }

  public async ativo() {
    await Http.get('/categoria').then((resposta: any) => {
      Metadata.getInstance<Select>('SelectCategoriAtivo').datasource.updateData(resposta.data.dataset.categoria);
    });
    await Http.get('/escopo').then((resposta: any) => {
      Metadata.getInstance<SelectMultiple>('SelectTagAtivo').datasource.updateData(resposta.data.dataset.escopo);
    });
    if (window.location.search === '') {
      this.titulo = 'Adicionar ativos';
      this.visibilidadeAdicionar = true;
    } else {
      this.visibilidadeBotao = true;
      await Http.get(`/ativo?NR=${window.location.search.slice(1)}`).then((resposta) => {
        const detalhesAtivo = resposta.data.dataset.detalheAtivo[0];
        this.titulo = detalhesAtivo.NMEQUIPAMENTO;
        this.categoria = detalhesAtivo.NRCATEGORIAEQUIP;
        Metadata.getInstance<Select>('SelectStatusAtivo').setValue(detalhesAtivo.IDSITUACAO);
        let escopos: any = [];
        if (detalhesAtivo.NRESCOPOMANUT !== null){
          escopos = detalhesAtivo.NRESCOPOMANUT.split(',').map((nr: any) => Number(nr));
        }
        Metadata.getInstance<SelectMultiple>('SelectTagAtivo').setValue(escopos);
        const imagens: any = [];
        detalhesAtivo.DSCAMINHO.split(',').forEach((dados: string, pos: number) => {
          imagens.push({
            id: `banco_${pos}`,
            src: dados,
          });
        });
        Metadata.getInstance<IterableCarousel>('carouselImagemDosAtivos').iterable.datasource.data = imagens;
      });
    }
  }

  public getUnidadeMedida({ component }: any) {
    Http.get('/unidadeMedida').then((resposta: any) => {
      component.datasource.updateData(resposta.data.dataset.unidadeMedida);
    });
  }

  public getProdutos({ component }: any) {
    Http.get('/produtos').then((resposta: any) => {
      component.datasource.updateData(resposta.data.dataset.produtos);
    });
  }

  public async salvarInsumo() {
    const formulario = Metadata.getInstance<Form>('FormParaCriarInsumos');
    if (formulario.validate()) {
      let arquivos: any = await this.updloadPictures('FileInput-ImagensInsumo_ColComCarroselDeImagens');
      Http.post('/insumos', { DADOS: formulario.value, IMAGENS: arquivos }).then((resposta) => {
        if (resposta.data.dataset.insumo[0] === 'OK') {
          this.dadosInsumo();
          this.fecharModalCriacaoInsumos();
          this.mensagemSucesso('Insumo salvo com sucesso!');
        } else {
          this.mensagemErro('ao salvar o insumo');
        }
      });
    }
  }

  public ordemServicos() {
    if (window.location.search === ''){
      Metadata.getInstance<Row>('linhaComCardsDeManutenção').isVisible = false;
    } else {
      Http.get(`/ordemServ?NR=${window.location.search.slice(1)}`).then((resposta) => {
        const manutencaoAgendada = Metadata.getInstance<IterableComponentRender>('IteracaoDeCardsManutencaoAgendada');
        manutencaoAgendada.datasource.updateData(resposta.data.dataset.ordens.filter((elemento: any) => elemento.IDSITUACAO === 'Pendente'));
        const historicoManutencao = Metadata.getInstance<IterableComponentRender>('IteracaoDeCardsHistoricoManutençao');
        historicoManutencao.datasource.updateData(resposta.data.dataset.ordens.filter((elemento: any) => elemento.IDSITUACAO === 'Concluída'));
      });
    }
  }

  public manutencaoEInsumosDeAtivos({ component }: any) {
    const dados: any = [];
    Http.get(`/insumoDeManutencao?NR=${window.location.search.slice(1)}`).then((resposta: any) => {
      this.tituloPagina = resposta.data.dataset.listaInsumos[0].NMEQUIPAMENTO;
      resposta.data.dataset.listaInsumos.forEach((elemento: any) => {
        let indexCategoria = dados.findIndex((dadosUnitario: any) => dadosUnitario.NRCATEGORIAMANUT === elemento.NRCATEGORIAMANUT);
        if (indexCategoria < 0) {
          dados.push({
            NRCATEGORIAMANUT: elemento.NRCATEGORIAMANUT,
            NMCATEGORIAMANUT: elemento.NMCATEGORIAMANUT,
            LISTA: [],
          });
          indexCategoria = dados.length - 1;
        }
        let indexTipoManut = dados[indexCategoria].LISTA.findIndex((dadosUnitario: any) => dadosUnitario.NRTIPOMANUTENCAO === elemento.NRTIPOMANUTENCAO);
        if (indexTipoManut < 0) {
          dados[indexCategoria].LISTA.push({
            NRTIPOMANUTENCAO: elemento.NRTIPOMANUTENCAO,
            NMTIPOMANUTENCAO: elemento.NMTIPOMANUTENCAO,
            css: (dados[indexCategoria].LISTA.length % 2 === 0) ?  'marginRigthCartTipoManutencao' : '',
            LISTA: [],
          });
          indexTipoManut = dados[indexCategoria].LISTA.length - 1;
        }
        if (elemento.DADOS !== null) {
          elemento.DADOS.split(',').forEach((elemento: any) => {
            const dadosElemento = elemento.split('|');
            dados[indexCategoria].LISTA[indexTipoManut].LISTA.push({
              NRINSUMO: Number(dadosElemento[0]),
              NMINSUMO: dadosElemento[1],
              CDINSUMO: dadosElemento[2],
              NMABREVUNIDADEMEDIDA: dadosElemento[3],
              QTMEDIDA: Number(dadosElemento[4]),
              BANCO: true,
            });
          })
        }
      });
    }).then(() => {
      component.datasource.updateData(dados);
    });
  }

  public dadosListaDoDatasource({ component }: any) {
    const id = component.name.split('_');
    const parentIterable = Metadata.getInstance<IterableComponentRender>(id[3].replaceAll('-','_'));
    const parentIndex = parentIterable.datasource.data.findIndex((row) => row[id[2]] === Number(id[1]));
    component.datasource.updateData(parentIterable.datasource.data[parentIndex].LISTA);
  }

  public listasDiponiveis({ component }: any, superior: any) {
    const dadosSelect: any = [];
    superior.datasource.data.forEach((elemento: any) => {
      if (Number(component.name.split('_')[1]) !== elemento.NRTIPOMANUTENCAO) {
        dadosSelect.push({
          NMTIPOMANUTENCAO: elemento.NMTIPOMANUTENCAO,
          NRTIPOMANUTENCAO: elemento.NRTIPOMANUTENCAO,
        });
      }
    });
    component.datasource.updateData(dadosSelect);
  }

  public getInsumos() {
    const dadosAExibir: any = [];
    Http.get('/insumos').then((resposta: any) => {
      resposta.data.dataset.insumo.forEach((elemento: any) => {
        dadosAExibir.push({
          NRINSUMO: elemento.NRINSUMO,
          NMINSUMO: elemento.NMINSUMO,
          CDINSUMO: elemento.CDINSUMO,
          NMABREVUNIDADEMEDIDA: elemento.NMABREVUNIDADEMEDIDA,
        })
      });
    }).then(() => {
      this.dadosDosInsumo = dadosAExibir;
    });
  }

  // Função que inclui novos valores a tabela de determinado tipo de manutenção
  public async incluirInsumo({ component }: any) {
    // Importa o datasource
    const iterable = Metadata.getInstance<IterableComponentRender>('IteracaoDeInsumosDeManutencao');
    // pega o nome do component para identificao o id
    const conjuntoNome = component.name.split('_');
    // Importa os dois components (Select, TextInput)
    const selectInsumoAdicionar = Metadata.getInstance<Select>(`SelectInsumosParaManutencao_${conjuntoNome[1]}_${conjuntoNome[2]}`);
    const qtdInsumoAdicionar = Metadata.getInstance<TextInput>(`CampoQuantidadeInsumo_${conjuntoNome[1]}_${conjuntoNome[2]}`);
    if (selectInsumoAdicionar.value !== null && qtdInsumoAdicionar.value !== '') {
      const dadosComQuantidade = selectInsumoAdicionar.value;
      dadosComQuantidade.QTMEDIDA = Number(qtdInsumoAdicionar.value);
      dadosComQuantidade.BANCO = false;
      const posSuperior = iterable.datasource.data.findIndex((elemento: any) => elemento.NRCATEGORIAMANUT === Number(conjuntoNome[1]));
      const pos = iterable.datasource.data[posSuperior].LISTA.findIndex((elemento: any) => elemento.NRTIPOMANUTENCAO === Number(conjuntoNome[2]));
      const copia = iterable.datasource.data;
      const posicao = copia[posSuperior].LISTA[pos].LISTA.findIndex((elemento: any) => elemento.NRINSUMO === dadosComQuantidade.NRINSUMO)
       if (posicao >= 0) {
         dadosComQuantidade.QTMEDIDA += Number(copia[posSuperior].LISTA[pos].LISTA[posicao].QTMEDIDA);
         dadosComQuantidade.BANCO = true;
         copia[posSuperior].LISTA[pos].LISTA.splice(posicao,1);
       }
       copia[posSuperior].LISTA[pos].LISTA.unshift(dadosComQuantidade);
       await iterable.datasource.updateData(copia);
       selectInsumoAdicionar.value = null;
       qtdInsumoAdicionar.value = '';
    }
  }

  public copiarDados(nr: number, itera: any) {
    this.verificaEAtualizaDadosDoIterable().then(() => {
      const NRCATEGORIAMANUT = itera.name.split('_')[1];
      const form = Metadata.getInstance<Form>('formDeCopia');
      if (form.validate()) {
        const NRTIPOMANUTENCAO = form.value[Object.keys(form.value)[0]];
        const listaInsumos = itera.datasource.data.filter((elemento: any) => elemento.NRTIPOMANUTENCAO === NRTIPOMANUTENCAO)[0].LISTA;
        // informações e/do iterable Superior a todos
        const iterable = Metadata.getInstance<IterableComponentRender>('IteracaoDeInsumosDeManutencao');
        const posSuperior = iterable.datasource.data.findIndex((elemento: any) => elemento.NRCATEGORIAMANUT === Number(NRCATEGORIAMANUT));
        const posOrigem = iterable.datasource.data[posSuperior].LISTA.findIndex((elemento: any) => elemento.NRTIPOMANUTENCAO === Number(NRTIPOMANUTENCAO));
        const posDestino = iterable.datasource.data[posSuperior].LISTA.findIndex((elemento: any) => elemento.NRTIPOMANUTENCAO === Number(nr));
        // --------------------
        const copia = iterable.datasource.data;
        const dadosCopiado: any = [];
        iterable.datasource.data[posSuperior].LISTA[posOrigem].LISTA.forEach((elemento: any, pos: number) => {
          const aCopiar = elemento;
          aCopiar.BANCO = false;
          const posExistente = iterable.datasource.data[posSuperior].LISTA[posDestino].LISTA.findIndex((elemento: any) => elemento.NRINSUMO === elemento.NRINSUMO)
          if (posExistente >= 0) {
            aCopiar.QTMEDIDA += iterable.datasource.data[posSuperior].LISTA[posOrigem].LISTA[pos].QTMEDIDA
            aCopiar.BANCO = iterable.datasource.data[posSuperior].LISTA[posOrigem].LISTA[pos].BANCO;
          }
          dadosCopiado.unshift(aCopiar);
        });
        copia[posSuperior].LISTA[posDestino].LISTA = dadosCopiado
        iterable.datasource.updateData(copia);
      }
      this.fecharModalCopiaTipoManutencao();
    });
  }

  public salvarInsumosDeManutencao() {
    this.verificaEAtualizaDadosDoIterable().then(() => {
      const dadosInsumoDeManutencao = Metadata.getInstance<IterableComponentRender>('IteracaoDeInsumosDeManutencao').datasource.data;
      Http.post('/relacaoInsumos', { NREQUIPAMENTO: Number(window.location.search.slice(1)), dados: dadosInsumoDeManutencao }).then((resposta: any) => {
        LoadingService.show('Salvando ...');
        if (resposta.data.dataset.relInsumos === 'OK'){
          LoadingService.hide();
          Router.replace(`/ativos?${window.location.search.slice(1)}`);
        } else {
          LoadingService.hide();
          this.mensagemErro('ao salvar os dados');
        }
      });
    })
  }

  public verificaEAtualizaDadosDoIterable(){
    return new Promise((resolve) => {
      const dadosIterable = Metadata.getInstance<IterableComponentRender>('IteracaoDeInsumosDeManutencao')
      const copia = dadosIterable.datasource.data
      dadosIterable.datasource.data.forEach((categoria: any, posCat: number) => {
        categoria.LISTA.forEach((manutencao: any, posManut: number) => {
          manutencao.LISTA.forEach((insumo: any, posInsu: number) => {
            const textoInput = Metadata.getInstance<TextInput>(`CampoQuantNRINSUMOadeInsumo_${categoria.NRCATEGORIAMANUT}_${manutencao.NRTIPOMANUTENCAO}_${insumo.NRINSUMO}`);
            copia[posCat].LISTA[posManut].LISTA[posInsu].QTMEDIDA = Number(textoInput.value);
          });
        });
      });
      dadosIterable.datasource.updateData(copia);
      resolve();
    });
  } 

  public async salvarAtivo({ component }: any) {
    if (component.name === 'BotaoSalvar_Modificar') {
      LoadingService.show('Salvando ...');
      let arquivos: any = await this.updloadPictures('FileInput-ImagensDoAtivo_carouselImagemDosAtivos')
      Http.post('/atualizarAtivo', {
        NR: window.location.search.slice(1),
        CATEGORIA: Metadata.getInstance<Select>('SelectCategoriAtivo').value,
        SITUACAO: Metadata.getInstance<Select>('SelectStatusAtivo').value,
        ESCOPO: Metadata.getInstance<SelectMultiple>('SelectTagAtivo').value,
        IMAGENS: arquivos,
      }).then((resposta: any) => {
        LoadingService.hide();
        if (resposta.data.dataset.resultado[0] === 'OK') {
          this.dadosCategoria();
          this.mensagemSucesso('Ativo alterado com salvo com sucesso!')
        } else {
          this.mensagemErro('ao tentar salvar as alterações no ativo');
        }
      });
    } else {
      const nome = Metadata.getInstance<TextInput>('TextInputNomeAtivo');
      const cod = Metadata.getInstance<TextInput>('TextInputCodigotivo');
      const categoria = Metadata.getInstance<Select>('SelectCategoriAtivo');
      const status = Metadata.getInstance<Select>('SelectStatusAtivo');
      nome.validate();
      cod.validate();
      categoria.validate();
      status.validate();
      if (nome.validate() && cod.validate() && categoria.validate() && status.validate()) {
        let arquivos: any = await this.updloadPictures('FileInput-ImagensDoAtivo_carouselImagemDosAtivos')
        LoadingService.show('Salvando ...');
        Http.post('/ativo', {
          NOME: nome.value,
          CODIGO: cod.value,
          CATEGORIA: categoria.value,
          SITUACAO: status.value,
          ESCOPO: Metadata.getInstance<SelectMultiple>('SelectTagAtivo').value,
          IMAGENS: arquivos,
        }).then((resposta: any) => {
          if (resposta.data.dataset.resultado[0] === 'OK') {
            this.dadosAtivo();
            this.mensagemSucesso('Ativo criado com salvo com sucesso!')
          } else {
            this.mensagemErro('ao tentar criar um ativo');
          };
          LoadingService.hide();
      });
      }
    }
  }

  public async updloadPictures(name: string) {
    const fileInputObject = Metadata.getInstance<FileInput>(name).value;
    let arquivos: any = [];
    if (fileInputObject && fileInputObject.length > 0){
        const types: IDictionary = ['image/jpg', 'image/jpeg', 'image/png'];
        const buildFilesPromises = fileInputObject.map((file: any) => {
          if (types.includes(file.type)) {
            return FileUpload.buildFileSendObject(file);
          }
        });
        await Promise.all(buildFilesPromises).then((files: any) => {
            arquivos  = files;
        });
      }
    return arquivos;
  }

  public salvarCategoria() {
    const formulario = Metadata.getInstance<Form>('FormParaCriarCategoria');
    if (formulario.validate()) {
    this.fecharModalCriacaoInsumos();
    LoadingService.show('Salvando ...');
      Http.post('/categoria', { NOME: formulario.value['TextInputNomeCategoria'], TIPOMANUT: formulario.value['SelectMultiploTipoManutencao'] }).then((resposta) => {
      LoadingService.hide();
        if (resposta.data.dataset.categoria[0] === 'OK') {
          this.mensagemSucesso('Categoria salvo com sucesso!')
          this.dadosCategoria();
        } else {
          this.mensagemErro('ao tentar criar uma nova categoria');
        }
      });
    }
  }

  public mensagemErro(msg: string) {
    DialogService.show({
            name: 'Dialog',
            title: 'Ops! Ocorreu um erro',
            text: `Ocorreu um erro ${msg}.<br>Tente novamente mais tarde!<br>Se o erro persistir, contacte o administrador do sistema.`,
          });
  }

  public mensagemSucesso(msg: string){
    AlertService.show({
            name: 'Alerta',
            text: msg,
            top: true,
            timeout: 1500,
            color: 'success',
          });
  }
}
