import { ZdPage } from '@zeedhi/vue';
import { ZdFramePage } from '@zeedhi/vuetify';

const routes = [
  {
    path: '/auth/login',
    name: 'login',
    component: ZdPage,
    props: {
      path: 'login',
      local: true,
    },
  },
  {
    path: '/',
    name: 'home',
    component: ZdPage,
    props: () => ({
      path: 'home',
      local: true,
    }),
  },
  {
    path: '/modules/:module/:page',
    name: 'microservice',
    component: () => import('../views/Microservice.vue'),
  },
  {
    path: '*',
    component: ZdPage,
    props: {
      path: 'notfound',
      local: true,
    },
  },
  {
    path: '/nome_que_aparecera_na_url',
    name: 'Nome da Tela',
    component: ZdFramePage,
    props: {
        type: 'post',
        params: {
            jsonPath: 'nome_arquivo',
            routePath: '/nome_na_rota_menu',
        },
    },
  },
  {
    path: '/fmt_dashboard',
    name: 'Dashboard Next',
    component: ZdFramePage,
    props: {
        type: 'post',
        params: {
            jsonPath: 'fmt_dashboard/fmt_dashboard',
            routePath: '/fmt_dashboard',
        },
    },
  },
  {
    path: '/parametrizacao',
    name: 'parametrizacao',
    component: ZdFramePage,
    props: () => ({
      path: 'layout_parametrizacao',
      local: true,
    }),
  },
  {
    path: '/fmt_parametrizacao',
    name: 'Parametrização',
    component: ZdPage,
    props: {
      path: 'fmt_parametrizacao/fmt_parametrizacao',
      local: true,
    },
  },
  {
    path: '/ordemdeservico',
    name: 'ordemServico',
    component: ZdFramePage,
    props: () => ({
      path: 'layout_ordemServico',
      local: true,
    }),
  },
  {
    path: '/novaordemservico',
    name: 'novaordemservico',
    component: ZdFramePage,
    props: () => ({
      path: 'layout_novaOrdemServico',
      local: true,
    }),
  },
  {
    path: '/ordemservico',
    name: 'ordemservico',
    component: ZdFramePage,
    props: () => ({
      path: 'layout_visualizacaoOrdemServico',
      local: true,
    }),
  },
  {
    path: '/converterSolicitacaoEmOrdem',
    name: 'converterSolicitacaoEmOrdem',
    component: ZdFramePage,
    props: () => ({
      path: 'layout_converterEmOrdemServico',
      local: true,
    }),
  },
  {
    path: '/login',
    name: 'login',
    component: ZdFramePage,
    props: () => ({
      path: 'login',
      local: true,
    }),
  },
  {
    path: '/ativosInsumos',
    name: 'Ativos, Categoria e Insumos',
    component: ZdFramePage,
    props: () => ({
      path: 'layout_ativosInsumos',
      local: true,
    }),
  },
  {
    path: '/fmt_ativos_insumos',
    name: 'Ativos, Categoria e Insumos',
    component: ZdPage,
    props: () => ({
      path: 'fmt_ativosInsumos/fmt_ativos_insumos',
      local: true,
    }),
  },
  {
    path: '/ativos',
    name: 'Detalhes de Ativos',
    component: ZdFramePage,
    props: () => ({
      path: 'layout_ativos',
      local: true,
    }),
  },
  {
    path: '/dashboardServico',
    name: 'Dashbord de Serviço',
    component: ZdFramePage,
    props: () => ({
      path: 'layout_dashboardDeServico',
      local: true,
    }),
  },
  {
    path: '/solicitacoes',
    name: 'lista de solicitações de serviço',
    component: ZdFramePage,
    props: () => ({
      path: 'layout_solicitacoesDeServico',
      local: true,
    }),
  },
  {
    path: '/fmt_solicitacoes_servicos',
    name: 'lista de solicitações de serviço',
    component: ZdFramePage,
    props: () => ({
      path: 'fmt_solicitacoes_servicos/fmt_solicitacoes_servicos',
      local: true,
    }),
  },
  {
    path: '/solicitacao',
    name: 'Detalhes da solicitação de serviço',
    component: ZdFramePage,
    props: () => ({
      path: 'layout_solicitacao',
      local: true,
    }),
  },
  {
    path: '/insumosDeAtivos',
    name: 'Detalhes de insumos para manutenção de Ativos',
    component: ZdFramePage,
    props: () => ({
      path: 'layout_insumosDeAtivos',
      local: true,
    }),
  },
  {
    path: '*',
    component: ZdFramePage,
    props: {
      path: 'notfound',
      local: true,
    },
  },
  {
    path: '/Dashboard',
    name: 'dashboard',
    component: ZdFramePage,
    props: {
      path: 'dashboard',
      local: true,
    },
  },
];

export default routes;
